## argagg 0.4.6

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 2.8 )
project( argagg CXX )

option(
  ARGAGG_BUILD_EXAMPLES
  "build examples"
  ON
)

option(
  ARGAGG_BUILD_TESTS
  "build tests"
  ON
)

option(
  ARGAGG_BUILD_DOCS
  "build docs"
  ON
)

set(
  ARGAGG_TEST_COMPILE_FLAGS
  "-g -Wall -Wextra -Wpedantic -Werror -std=c++11"
  CACHE STRING "Compiler flags for all project targets"
)

# When RPM packages are built CMake is invoked with a -DINCLUDE_INSTALL_DIR
# that we should respect. If it isn't present then we default it to "include".
set(
  INCLUDE_INSTALL_DIR "include"
  CACHE STRING "Include install folder name (default: include)"
)

# When RPM packages are built CMake is invoked with a -DLIB_INSTALL_DIR that we
# should respect. This is important because this is how the RPM build process
# specifies installation into "lib64" instead of "lib". If it isn't present
# then we default it to "lib".
set(
  LIB_INSTALL_DIR "lib"
  CACHE STRING "Library install folder name (default: lib)"
)

# When RPM packages are built CMake is invoked with a -DSHARE_INSTALL_PREFIX
# that we should respect. This is particularly important because this is how
# the RPM build process specifies installation of shared data files into
# "/usr/share". If it isn't present then we default it to "share" relative to
# the CMAKE_INSTALL_PREFIX which is incidentally the same path when the install
# prefix is "/usr".
set(
  SHARE_INSTALL_PREFIX share
  CACHE STRING "Shared data install folder name (default: share)"
)


# Set up a target to install the program which amounts to copying the single
# header file.
install(
  DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/include"
  DESTINATION "${INCLUDE_INSTALL_DIR}/.."
)


# Build examples if configured to.
if( ARGAGG_BUILD_EXAMPLES )
  add_executable( joinargs "examples/joinargs.cpp" )
  set_target_properties(
    joinargs
    PROPERTIES
      COMPILE_FLAGS "${ARGAGG_TEST_COMPILE_FLAGS}"
      INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}/include"
      RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin"
  )

  add_executable( gengetopt_main1 "examples/gengetopt_main1.cpp" )
  set_target_properties(
    gengetopt_main1
    PROPERTIES
      COMPILE_FLAGS "${ARGAGG_TEST_COMPILE_FLAGS}"
      INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}/include"
      RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin"
      OUTPUT_NAME sample1
  )
endif()


# Build and register the unit tests if configured to.
if( ARGAGG_BUILD_TESTS )
  enable_testing()
  add_executable( argagg_test "test/test.cpp" )
  set_target_properties(
    argagg_test
    PROPERTIES
      COMPILE_FLAGS "${ARGAGG_TEST_COMPILE_FLAGS}"
      RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin"
  )
  add_test(
    NAME argagg_test
    COMMAND argagg_test
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/bin"
  )
endif()


# Build Doxygen documentation if we can find Doxygen and we're configured to
# build documentation.
find_program( DOXYGEN doxygen )
if( ARGAGG_BUILD_DOCS AND DOXYGEN )

  # Everyone loves documentation! Lets set up a target to generate documentation.
  # First lets collect everything that we think can change the documentation.
  # This basically means everything inside the "docs" folder along with every
  # header and source file. If one of those changes then we want to mark the
  # documentation for regeneration.
  file(
    GLOB_RECURSE DOC_INPUTS
    "${CMAKE_CURRENT_SOURCE_DIR}/doc/*"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/*"
    "${CMAKE_CURRENT_SOURCE_DIR}/test/*"
  )
  
  # Like the version.hpp header file we're going to replace some CMake variables
  # in the doxygen configuration with actual values.
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/doc/doxygen.cfg.in
    ${CMAKE_BINARY_DIR}/doxygen.cfg
    @ONLY
  )
  
  # Now we add a command for CMake to run to generate documentation.
  add_custom_command(
    # We tell CMake that this command will generate the `html` and `xml`
    # folders inside the project's documentation share folder inside the build
    # folder. Specifying these outputs explicitly adds them to the "clean"
    # target. Note that we put the documentation into the "share" folder in the
    # build folder. This is to structure the build folder as a prefix.
    OUTPUT
      "${CMAKE_BINARY_DIR}/share/doc/${PROJECT_NAME}/html"
      "${CMAKE_BINARY_DIR}/share/doc/${PROJECT_NAME}/xml"
    # This command makes sure that the output folder exists first.
    COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_BINARY_DIR}/share/doc/${PROJECT_NAME}"
    # This command performs the doxygen documentation generation.
    COMMAND ${DOXYGEN} doxygen.cfg
    # Run the above commands in the build folder.
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}"
    # Tell CMake that if any of the documentation input files we collected change
    # then this command needs to be re-run.
    DEPENDS
      ${CMAKE_BINARY_DIR}/doxygen.cfg
      ${DOC_INPUTS}
  )
  
  # This creates an "empty target" named "docs" that doesn't produce output, but
  # depends on the generated documentation. The result is we can run "make docs"
  # and it behaves the way we expect. It also doesn't regenerate documentation if
  # the outputs specified below are up-to-date.
  add_custom_target(
    docs ALL
    DEPENDS
      "${CMAKE_BINARY_DIR}/share/doc/${PROJECT_NAME}/html"
      "${CMAKE_BINARY_DIR}/share/doc/${PROJECT_NAME}/xml"
  )
  
  # Finally set up an installation target for the documentation.
  install(
    DIRECTORY "${CMAKE_BINARY_DIR}/share/"
    DESTINATION "${SHARE_INSTALL_PREFIX}"
  )

endif()

=== debian/changelog ===
argagg (0.4.6-6) unstable; urgency=medium

  * Orphan package

  [ Debian Janitor ]
  * Set upstream metadata fields

  [ Didier Raboud ]
  * S-V: Update to 4.6.0 without changes needed
  * Run wrap-and-sort -baskt
  * Fix MIT/Expat license name, thanks to cme
  * Bump debhelper compat to 13

 -- Didier Raboud <odyx@debian.org>  Wed, 01 Sep 2021 15:53:51 +0200

argagg (0.4.6-5) unstable; urgency=medium

  * Bump debhelper from old 11 to 12.
  * Bump S-V to 4.4 without changes needed
  * Convert patch-queue to git debrebase

 -- Didier Raboud <odyx@debian.org>  Fri, 20 Sep 2019 16:40:13 +0200

argagg (0.4.6-4) unstable; urgency=medium

  * Cleanup d/control thanks to `cme update dpkg-control`
  * Update Vcs-* for the move to Salsa
  * Bump debhelper compat to 11

 -- Didier Raboud <odyx@debian.org>  Fri, 23 Feb 2018 20:52:18 +0100

argagg (0.4.6-3) unstable; urgency=medium

  [ Chris Lamb ]
  * Make the build reproducible (Closes: #879569)

 -- Didier Raboud <odyx@debian.org>  Mon, 23 Oct 2017 08:06:46 +0200

argagg (0.4.6-2) unstable; urgency=medium

  * Mark argagg-dev Multi-Arch: foreign
  * Add gbp.conf

 -- Didier Raboud <odyx@debian.org>  Sun, 22 Oct 2017 17:53:00 +0200

argagg (0.4.6-1) unstable; urgency=low

  * Initial release. (Closes: #878641)

 -- Didier Raboud <odyx@debian.org>  Fri, 20 Oct 2017 13:00:01 +0200

=== debian/control ===
Source: argagg
Maintainer: Debian QA Group <packages@qa.debian.org>
Section: devel
Priority: optional
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 doctest-dev,
 doxygen,
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/debian/argagg
Vcs-Git: https://salsa.debian.org/debian/argagg.git
Homepage: https://github.com/vietjtnguyen/argagg

Package: argagg-dev
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Argument Aggregator - Simple C++11 command line argument parser
 This is yet another C++ command line argument/option parser. It was
 written as a simple and idiomatic alternative to other frameworks like
 getopt, Boost program options, TCLAP, and others. The goal is to achieve
 the majority of argument parsing needs in a simple manner with an easy
 to use API. It operates as a single pass over all arguments, recognizing
 flags prefixed by - (short) or -- (long) and aggregating them into easy
 to access structures with lots of convenience functions. It defers
 processing types until you access them, so the result structures end up
 just being pointers into the original command line argument C-strings.
 .
 argagg supports POSIX recommended argument syntax conventions.

Package: argagg-dev-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 libjs-jquery,
 ${misc:Depends},
Description: Argument Aggregator - Simple C++11 command line argument parser - source doc
 This is yet another C++ command line argument/option parser. It was
 written as a simple and idiomatic alternative to other frameworks like
 getopt, Boost program options, TCLAP, and others. The goal is to achieve
 the majority of argument parsing needs in a simple manner with an easy
 to use API. It operates as a single pass over all arguments, recognizing
 flags prefixed by - (short) or -- (long) and aggregating them into easy
 to access structures with lots of convenience functions. It defers
 processing types until you access them, so the result structures end up
 just being pointers into the original command line argument C-strings.
 .
 argagg supports POSIX recommended argument syntax conventions.
 .
 This package contains the doxygen documentation for the argagg source code.

## argagg 0.4.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,23 @@
 cmake_minimum_required( VERSION 2.8 )
 project( argagg CXX )
+
+add_library(
+  argagg
+  INTERFACE
+)
+
+add_library(
+  argagg::argagg
+  ALIAS
+  argagg
+)
+
+target_include_directories(
+  argagg
+  INTERFACE
+  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
+  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
+)
 
 option(
   ARGAGG_BUILD_EXAMPLES
@@ -21,7 +39,7 @@
 
 set(
   ARGAGG_TEST_COMPILE_FLAGS
-  "-g -Wall -Wextra -Wpedantic -Werror -std=c++11"
+  "-g -Wall -Wextra -Wpedantic -Wsign-conversion -Werror -std=c++11"
   CACHE STRING "Compiler flags for all project targets"
 )
 
@@ -68,7 +86,7 @@
     joinargs
     PROPERTIES
       COMPILE_FLAGS "${ARGAGG_TEST_COMPILE_FLAGS}"
-      INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}/include"
+      LINK_LIBRARIES argagg
       RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin"
   )
 
@@ -77,7 +95,7 @@
     gengetopt_main1
     PROPERTIES
       COMPILE_FLAGS "${ARGAGG_TEST_COMPILE_FLAGS}"
-      INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}/include"
+      LINK_LIBRARIES argagg
       RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin"
       OUTPUT_NAME sample1
   )
@@ -87,7 +105,40 @@
 # Build and register the unit tests if configured to.
 if( ARGAGG_BUILD_TESTS )
   enable_testing()
-  add_executable( argagg_test "test/test.cpp" )
+
+  list( APPEND ARGAGG_TEST_SOURCES "test/test.cpp" )
+  list( APPEND ARGAGG_TEST_SOURCES "test/test_csv.cpp" )
+
+  find_path( OPENCV_INCLUDE_DIR "opencv2/opencv.hpp" )
+  find_library( OPENCV_CORE_LIBRARY opencv_core )
+  if( OPENCV_INCLUDE_DIR AND OPENCV_CORE_LIBRARY )
+    list( APPEND ARGAGG_TEST_SOURCES "test/test_opencv.cpp" )
+    list( APPEND ARGAGG_TEST_INCLUDE_DIRS ${OPENCV_INCLUDE_DIR} )
+    list( APPEND ARGAGG_TEST_LIB_DEPS ${OPENCV_CORE_LIBRARY} )
+  else()
+    message( "Unable to find OpenCV, disabling test_opencv.cpp" )
+  endif()
+
+  add_executable( argagg_test ${ARGAGG_TEST_SOURCES} )
+
+  list( LENGTH ARGAGG_TEST_INCLUDE_DIRS ARGAGG_TEST_INCLUDE_DIRS_LENGTH )
+  if( ARGAGG_TEST_INCLUDE_DIRS_LENGTH GREATER 0 )
+    target_include_directories(
+      argagg_test
+      PRIVATE
+      ${ARGAGG_TEST_INCLUDE_DIRS}
+    )
+  endif()
+
+  list( LENGTH ARGAGG_TEST_LIB_DEPS ARGAGG_TEST_LIB_DEPS_LENGTH )
+  if( ARGAGG_TEST_LIB_DEPS_LENGTH GREATER 0 )
+    target_link_libraries(
+      argagg_test
+      PRIVATE
+      ${ARGAGG_TEST_LIB_DEPS}
+    )
+  endif()
+
   set_target_properties(
     argagg_test
     PROPERTIES
@@ -118,7 +169,7 @@
     "${CMAKE_CURRENT_SOURCE_DIR}/include/*"
     "${CMAKE_CURRENT_SOURCE_DIR}/test/*"
   )
-  
+
   # Like the version.hpp header file we're going to replace some CMake variables
   # in the doxygen configuration with actual values.
   configure_file(
@@ -126,7 +177,7 @@
     ${CMAKE_BINARY_DIR}/doxygen.cfg
     @ONLY
   )
-  
+
   # Now we add a command for CMake to run to generate documentation.
   add_custom_command(
     # We tell CMake that this command will generate the `html` and `xml`
@@ -149,7 +200,7 @@
       ${CMAKE_BINARY_DIR}/doxygen.cfg
       ${DOC_INPUTS}
   )
-  
+
   # This creates an "empty target" named "docs" that doesn't produce output, but
   # depends on the generated documentation. The result is we can run "make docs"
   # and it behaves the way we expect. It also doesn't regenerate documentation if
@@ -160,7 +211,7 @@
       "${CMAKE_BINARY_DIR}/share/doc/${PROJECT_NAME}/html"
       "${CMAKE_BINARY_DIR}/share/doc/${PROJECT_NAME}/xml"
   )
-  
+
   # Finally set up an installation target for the documentation.
   install(
     DIRECTORY "${CMAKE_BINARY_DIR}/share/"

=== debian/changelog ===
argagg (0.4.7-4) unstable; urgency=medium

  * QA upload.
  * debian/copyright: Update packaging copyright information.
  * debian/tests/*: Create autopkgtest.

 -- Henrique Romaniuk Ramalho <henriqueramalho@alunos.utfpr.edu.br>  Tue, 28 Oct 2025 18:50:38 -0300

argagg (0.4.7-3) unstable; urgency=medium

  * QA upload.
  * Bump CMake policy version (Closes: #1112706)

 -- Timo Röhling <roehling@debian.org>  Wed, 24 Sep 2025 21:28:58 +0200

argagg (0.4.7-2) unstable; urgency=medium

  * QA upload.
  * Add patch to avoid errors on casting unsigned/signed 
    (Closes: #1103065)

 -- Andreas Rönnquist <gusnan@debian.org>  Fri, 02 May 2025 12:59:03 +0200

argagg (0.4.7-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.
  * debian/patches: Refresh patches.
  * debian/gbp.conf: Fix master branch name.

 -- Boyuan Yang <byang@debian.org>  Fri, 27 Jan 2023 13:13:35 -0500

argagg (0.4.6-7) unstable; urgency=medium

  * QA upload.

  [ Didier Raboud ]
  * Add Salsa CI configuration

 -- Jelmer Vernooĳ <jelmer@debian.org>  Wed, 25 May 2022 18:58:28 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  debhelper-compat (= 13),
  doctest-dev,
  doxygen,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian/argagg
 Vcs-Git: https://salsa.debian.org/debian/argagg.git
 Homepage: https://github.com/vietjtnguyen/argagg

=== debian/tests/control ===
Tests: execution_test.sh
Depends: @, g++

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/argagg-$1\.tar\.gz/ \
  https://github.com/vietjtnguyen/argagg/tags .*/v?(\d\S+)\.tar\.gz
